<?php
if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class Donor extends REF_Controller {
    public function __construct() {
        parent::__construct();
        $this->load->library('upload');
        $this->load->model('donor_model', '', TRUE);
        $this->uri_key_index = 0;
    }
    
    public function index() {
        $data = array();
        $data['results'] = $this->donor_model->list_all();
        if (!empty($this->session->flashdata('success'))) 
            $data['success'] = $this->session->flashdata('success');
        else 
            $data['error'] = $this->session->flashdata('error');
        
        $actions = $this->actions();
        $data['add_btn']    = 'Create New Donor Sponsor';
        $data['view_link']  = $actions['view'] . '/';
        $data['add_link']   = $actions['add'];
        $data['edit_link']  = $actions['edit'] . '/';
        $data['delete_link']= $actions['delete'] . '/';
        
        $service_menu_id = get_master_controller_id($actions['controller']);
        $data['service_menu_id'] = array('service_menu_id' => $service_menu_id, 'menu_type' => '1');
        $this->render($data, 'donor/list');
    }
    
    private function get_donor_url_key($name, $id = '') {
        $url_key = get_url_key($name);
        if ($this->donor_model->donor_url_key_exists($url_key, $id)) {
            $this->uri_key_index ++;
            return $this->get_donor_url_key($name . '_' . $this->uri_key_index, $id);
        }
        
        return $url_key;
    }
    
    public function add() {
        $data = array();
        $actions = $this->actions();
        $data['form_action'] = $actions['insert'];
        $this->render($data, 'donor/add');
    }
    
    public function insert() {
        $insert = array(
            'name' => $this->input->post('name'),
            'tamil_name' => htmlspecialchars( $this->input->post('tamil_name') ),
            'donation_for'=> $this->input->post('donation_for'),
            'phone' => $this->input->post('phone_no'),
            #'fax' => $this->input->post('fax'),
            'email' => $this->input->post('email'),
            #'website' => $this->input->post('website'),
            #'unit_no' => $this->input->post('unit_no'),
            'address'=> $this->input->post('address'),
            #'blk' => $this->input->post('blk'),
            'url_key' => $this->get_donor_url_key($this->input->post('name')),
            'status' => $this->input->post('status'),
            'created_by' => $this->user_data['user_id'],
            'created_on' => date('Y-m-d H:i:s')
        );
        
        $insert_id = $this->donor_model->insert($insert);  
        if ($insert_id > 0)
            $this->session->set_flashdata('success', 'Donor Sponsor details added successfully');    
        
        else
            $this->session->set_flashdata('error', 'Donor Sponsor details not added!');
        redirect('donor', 'refresh');
    }
    
    public function edit($id = '') {
        if (empty($id)) {
            show_400_error();
        }
        
        $data = array();
        $data['donor'] = $this->donor_model->get_by_id($id);
        $actions = $this->actions();
        $data['form_action'] = $actions['update'] . '/' . $id;
        $this->render($data, 'donor/edit');
    }
    
    public function update($id = '') {
        if (empty($id)) {
            show_400_error();
        }
        
        $update = array(
            'name' => $this->input->post('name'),
            'tamil_name' => htmlspecialchars( $this->input->post('tamil_name') ),
            'donation_for'=> $this->input->post('donation_for'),
            'phone' => $this->input->post('phone_no'),
            #'fax' => $this->input->post('fax'),
            'email' => $this->input->post('email'),
            #'website' => $this->input->post('website'),
            #'unit_no' => $this->input->post('unit_no'),
            'address'=> $this->input->post('address'),
            #'blk' => $this->input->post('blk'),
            'url_key' => $this->get_donor_url_key($this->input->post('name')),
            'status' => $this->input->post('status'),
            'updated_by' => $this->user_data['user_id'],
            'updated_on' => date('Y-m-d H:i:s')
        );
        
        
        if ( $this->donor_model->update($update, $id) > 0)
            $this->session->set_flashdata('success', 'Donor Sponsor details updated successfully');  
       
        else
            $this->session->set_flashdata('error', 'Donor Sponsor details not updated!');    
        
        redirect('donor','refresh');
    }
    
    public function view($id = '') {
        if (empty($id)) {
            show_400_error();
        }
        
        $data = array();
        $data['donor'] = $this->donor_model->get_by_id($id);
        $this->render($data, 'donor/view');
    }
    
    public function delete($id = '') {
        if (empty($id)) {
            show_400_error();
        }
        
        $update = array ( 
            'status' => 2,
            'updated_by' => $this->user_data['user_id'],
            'updated_on' => date('Y-m-d H:i:s')
        );
        
        if ($this->donor_model->update($update,$id) > 0)
            $this->session->set_flashdata('success', 'Donor Sponsor details  deleted successfully');
            
        else 
            $this->session->set_flashdata('error', 'Donor Sponsor details  not deleted!');
        
        redirect( 'donor', 'refresh');
    }
}
?>